<?php

declare(strict_types=1);

namespace App\Doctrine\Booking;

use ApiPlatform\Metadata\Operation;
use App\Doctrine\AbstractExtension;
use App\Entity\Access\Access;
use App\Entity\Booking\AttendanceBookingReason;
use Doctrine\ORM\QueryBuilder;
use Symfony\Bundle\SecurityBundle\Security;

/**
 * Class AttendanceBookingReasonExtension : Filtre de sécurité par défaut pour une resource AttendanceBookingReason.
 */
final class AttendanceBookingReasonExtension extends AbstractExtension
{
    public function __construct(private Security $security)
    {
    }

    public function supports(string $resourceClass, ?Operation $operation): bool
    {
        return $resourceClass === AttendanceBookingReason::class;
    }

    protected function addWhere(QueryBuilder $queryBuilder, string $resourceClass, ?Operation $operation): void
    {
        /** @var Access $currentUser */
        $currentUser = $this->security->getUser();
        if ($currentUser === null || $currentUser->getOrganization() === null) {
            return;
        }
        $rootAlias = $queryBuilder->getRootAliases()[0];
        $queryBuilder
            ->andWhere(sprintf('%s.organization = :organization', $rootAlias))
            ->setParameter('organization', $currentUser->getOrganization())
        ;
    }
}
